# Generated by ariadne-codegen

from typing import Any, Dict, Optional, Union

from .base_operation import GraphQLField
from .custom_typing_fields import (
    AggregateCacheGraphQLField,
    ClusterGraphQLField,
    ClusterNodeGraphQLField,
    ColumnGraphQLField,
    CreateCubeOutputGraphQLField,
    CreateJoinOutputGraphQLField,
    CreateTableOutputGraphQLField,
    CubeGraphQLField,
    CubeRestrictionGraphQLField,
    CubeRestrictionIsInConditionGraphQLField,
    CubeRestrictionLeafConditionUnion,
    CubeRestrictionRelationalConditionGraphQLField,
    DatabaseGraphQLField,
    DataLoadUnion,
    DataModelGraphQLField,
    DataSourceDataModelUnion,
    DataSourceGraphQLField,
    DataSourceIdentifierGraphQLField,
    DataSourceLoadUnion,
    DeleteCubeRestrictionsOutputGraphQLField,
    DeleteJoinOutputGraphQLField,
    DeleteTableOutputGraphQLField,
    DimensionGraphQLField,
    FileSystemDataSourceDataModelGraphQLField,
    FileSystemDataSourceLoadGraphQLField,
    FileSystemFileGraphQLField,
    HierarchyGraphQLField,
    IdentifiedDataSourceLoadGraphQLField,
    JdbcDataSourceLoadGraphQLField,
    JoinGraphQLField,
    JoinMappingItemGraphQLField,
    LevelGraphQLField,
    MeasureGraphQLField,
    NodeGraphQLField,
    ParameterGraphQLField,
    TableGraphQLField,
    UpdatableCellsGraphQLField,
    UpdateAggregateCacheOutputGraphQLField,
    UpdateColumnOutputGraphQLField,
    UpdateCubeRestrictionsOutputGraphQLField,
    UpdateDatabaseOutputGraphQLField,
    UpdateHierarchyOutputGraphQLField,
    UpdateUpdatableCellsOutputGraphQLField,
)


class AggregateCacheFields(GraphQLField):
    capacity: "AggregateCacheGraphQLField" = AggregateCacheGraphQLField("capacity")

    @classmethod
    def measures(cls) -> "MeasureFields":
        return MeasureFields("measures")

    def fields(
        self, *subfields: Union[AggregateCacheGraphQLField, "MeasureFields"]
    ) -> "AggregateCacheFields":
        """Subfields should come from the AggregateCacheFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "AggregateCacheFields":
        self._alias = alias
        return self


class ClusterFields(GraphQLField):
    @classmethod
    def nodes(cls) -> "ClusterNodeFields":
        return ClusterNodeFields("nodes")

    type: "ClusterGraphQLField" = ClusterGraphQLField("type")

    def fields(
        self, *subfields: Union[ClusterGraphQLField, "ClusterNodeFields"]
    ) -> "ClusterFields":
        """Subfields should come from the ClusterFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "ClusterFields":
        self._alias = alias
        return self


class ClusterNodeFields(GraphQLField):
    name: "ClusterNodeGraphQLField" = ClusterNodeGraphQLField("name")

    def fields(self, *subfields: ClusterNodeGraphQLField) -> "ClusterNodeFields":
        """Subfields should come from the ClusterNodeFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "ClusterNodeFields":
        self._alias = alias
        return self


class ColumnFields(GraphQLField):
    data_type: "ColumnGraphQLField" = ColumnGraphQLField("dataType")
    default_value: "ColumnGraphQLField" = ColumnGraphQLField("defaultValue")
    id: "ColumnGraphQLField" = ColumnGraphQLField("id")
    name: "ColumnGraphQLField" = ColumnGraphQLField("name")

    @classmethod
    def table(cls) -> "TableFields":
        return TableFields("table")

    def fields(
        self, *subfields: Union[ColumnGraphQLField, "TableFields"]
    ) -> "ColumnFields":
        """Subfields should come from the ColumnFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "ColumnFields":
        self._alias = alias
        return self


class CreateCubeOutputFields(GraphQLField):
    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    def fields(
        self, *subfields: Union[CreateCubeOutputGraphQLField, "CubeFields"]
    ) -> "CreateCubeOutputFields":
        """Subfields should come from the CreateCubeOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CreateCubeOutputFields":
        self._alias = alias
        return self


class CreateJoinOutputFields(GraphQLField):
    @classmethod
    def join(cls) -> "JoinFields":
        return JoinFields("join")

    def fields(
        self, *subfields: Union[CreateJoinOutputGraphQLField, "JoinFields"]
    ) -> "CreateJoinOutputFields":
        """Subfields should come from the CreateJoinOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CreateJoinOutputFields":
        self._alias = alias
        return self


class CreateTableOutputFields(GraphQLField):
    @classmethod
    def table(cls) -> "TableFields":
        return TableFields("table")

    def fields(
        self, *subfields: Union[CreateTableOutputGraphQLField, "TableFields"]
    ) -> "CreateTableOutputFields":
        """Subfields should come from the CreateTableOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CreateTableOutputFields":
        self._alias = alias
        return self


class CubeFields(GraphQLField):
    @classmethod
    def aggregate_cache(cls) -> "AggregateCacheFields":
        return AggregateCacheFields("aggregate_cache")

    @classmethod
    def cluster(cls) -> "ClusterFields":
        return ClusterFields("cluster")

    @classmethod
    def data_model(cls) -> "DataModelFields":
        return DataModelFields("data_model")

    @classmethod
    def dimension(cls, name: str) -> "DimensionFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return DimensionFields("dimension", arguments=cleared_arguments)

    @classmethod
    def dimensions(cls) -> "DimensionFields":
        return DimensionFields("dimensions")

    @classmethod
    def fact_table(cls) -> "TableFields":
        return TableFields("fact_table")

    id: "CubeGraphQLField" = CubeGraphQLField("id")

    @classmethod
    def measure(cls, name: str) -> "MeasureFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return MeasureFields("measure", arguments=cleared_arguments)

    @classmethod
    def measures(cls) -> "MeasureFields":
        return MeasureFields("measures")

    name: "CubeGraphQLField" = CubeGraphQLField("name")

    @classmethod
    def restriction(cls, role_name: str) -> "CubeRestrictionFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "roleName": {"type": "String!", "value": role_name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return CubeRestrictionFields("restriction", arguments=cleared_arguments)

    @classmethod
    def restrictions(cls) -> "CubeRestrictionFields":
        return CubeRestrictionFields("restrictions")

    @classmethod
    def updatable_cells(cls) -> "UpdatableCellsFields":
        return UpdatableCellsFields("updatable_cells")

    def fields(
        self,
        *subfields: Union[
            CubeGraphQLField,
            "AggregateCacheFields",
            "ClusterFields",
            "CubeRestrictionFields",
            "DataModelFields",
            "DimensionFields",
            "MeasureFields",
            "TableFields",
            "UpdatableCellsFields",
        ]
    ) -> "CubeFields":
        """Subfields should come from the CubeFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CubeFields":
        self._alias = alias
        return self


class CubeRestrictionFields(GraphQLField):
    condition: "CubeRestrictionLeafConditionUnion" = CubeRestrictionLeafConditionUnion(
        "condition"
    )
    id: "CubeRestrictionGraphQLField" = CubeRestrictionGraphQLField("id")
    role_name: "CubeRestrictionGraphQLField" = CubeRestrictionGraphQLField("roleName")

    def fields(
        self,
        *subfields: Union[
            CubeRestrictionGraphQLField, "CubeRestrictionLeafConditionUnion"
        ]
    ) -> "CubeRestrictionFields":
        """Subfields should come from the CubeRestrictionFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CubeRestrictionFields":
        self._alias = alias
        return self


class CubeRestrictionIsInConditionFields(GraphQLField):
    elements: "CubeRestrictionIsInConditionGraphQLField" = (
        CubeRestrictionIsInConditionGraphQLField("elements")
    )
    operator: "CubeRestrictionIsInConditionGraphQLField" = (
        CubeRestrictionIsInConditionGraphQLField("operator")
    )

    @classmethod
    def subject(cls) -> "LevelFields":
        return LevelFields("subject")

    def fields(
        self, *subfields: Union[CubeRestrictionIsInConditionGraphQLField, "LevelFields"]
    ) -> "CubeRestrictionIsInConditionFields":
        """Subfields should come from the CubeRestrictionIsInConditionFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CubeRestrictionIsInConditionFields":
        self._alias = alias
        return self


class CubeRestrictionRelationalConditionFields(GraphQLField):
    operator: "CubeRestrictionRelationalConditionGraphQLField" = (
        CubeRestrictionRelationalConditionGraphQLField("operator")
    )

    @classmethod
    def subject(cls) -> "LevelFields":
        return LevelFields("subject")

    target: "CubeRestrictionRelationalConditionGraphQLField" = (
        CubeRestrictionRelationalConditionGraphQLField("target")
    )

    def fields(
        self,
        *subfields: Union[CubeRestrictionRelationalConditionGraphQLField, "LevelFields"]
    ) -> "CubeRestrictionRelationalConditionFields":
        """Subfields should come from the CubeRestrictionRelationalConditionFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "CubeRestrictionRelationalConditionFields":
        self._alias = alias
        return self


class DataModelFields(GraphQLField):
    @classmethod
    def cube(cls, name: str) -> "CubeFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return CubeFields("cube", arguments=cleared_arguments)

    @classmethod
    def cubes(cls) -> "CubeFields":
        return CubeFields("cubes")

    @classmethod
    def database(cls) -> "DatabaseFields":
        return DatabaseFields("database")

    id: "DataModelGraphQLField" = DataModelGraphQLField("id")
    transaction_id: "DataModelGraphQLField" = DataModelGraphQLField("transactionId")

    def fields(
        self, *subfields: Union[DataModelGraphQLField, "CubeFields", "DatabaseFields"]
    ) -> "DataModelFields":
        """Subfields should come from the DataModelFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DataModelFields":
        self._alias = alias
        return self


class DataSourceFields(GraphQLField):
    data_model: "DataSourceDataModelUnion" = DataSourceDataModelUnion("dataModel")
    id: "DataSourceGraphQLField" = DataSourceGraphQLField("id")
    key: "DataSourceGraphQLField" = DataSourceGraphQLField("key")
    name: "DataSourceGraphQLField" = DataSourceGraphQLField("name")

    def fields(
        self, *subfields: Union[DataSourceGraphQLField, "DataSourceDataModelUnion"]
    ) -> "DataSourceFields":
        """Subfields should come from the DataSourceFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DataSourceFields":
        self._alias = alias
        return self


class DataSourceIdentifierFields(GraphQLField):
    data_source_name: "DataSourceIdentifierGraphQLField" = (
        DataSourceIdentifierGraphQLField("dataSourceName")
    )

    def fields(
        self, *subfields: DataSourceIdentifierGraphQLField
    ) -> "DataSourceIdentifierFields":
        """Subfields should come from the DataSourceIdentifierFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DataSourceIdentifierFields":
        self._alias = alias
        return self


class DatabaseFields(GraphQLField):
    owners: "DatabaseGraphQLField" = DatabaseGraphQLField("owners")
    readers: "DatabaseGraphQLField" = DatabaseGraphQLField("readers")

    @classmethod
    def table(cls, name: str) -> "TableFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return TableFields("table", arguments=cleared_arguments)

    @classmethod
    def tables(cls) -> "TableFields":
        return TableFields("tables")

    def fields(
        self, *subfields: Union[DatabaseGraphQLField, "TableFields"]
    ) -> "DatabaseFields":
        """Subfields should come from the DatabaseFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DatabaseFields":
        self._alias = alias
        return self


class DeleteCubeRestrictionsOutputFields(GraphQLField):
    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    def fields(
        self, *subfields: Union[DeleteCubeRestrictionsOutputGraphQLField, "CubeFields"]
    ) -> "DeleteCubeRestrictionsOutputFields":
        """Subfields should come from the DeleteCubeRestrictionsOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DeleteCubeRestrictionsOutputFields":
        self._alias = alias
        return self


class DeleteJoinOutputFields(GraphQLField):
    @classmethod
    def tables(cls) -> "TableFields":
        return TableFields("tables")

    def fields(
        self, *subfields: Union[DeleteJoinOutputGraphQLField, "TableFields"]
    ) -> "DeleteJoinOutputFields":
        """Subfields should come from the DeleteJoinOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DeleteJoinOutputFields":
        self._alias = alias
        return self


class DeleteTableOutputFields(GraphQLField):
    @classmethod
    def tables(cls) -> "TableFields":
        return TableFields("tables")

    def fields(
        self, *subfields: Union[DeleteTableOutputGraphQLField, "TableFields"]
    ) -> "DeleteTableOutputFields":
        """Subfields should come from the DeleteTableOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DeleteTableOutputFields":
        self._alias = alias
        return self


class DimensionFields(GraphQLField):
    caption: "DimensionGraphQLField" = DimensionGraphQLField("caption")

    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    @classmethod
    def default_hierarchy(cls) -> "HierarchyFields":
        return HierarchyFields("default_hierarchy")

    @classmethod
    def hierarchies(cls) -> "HierarchyFields":
        return HierarchyFields("hierarchies")

    @classmethod
    def hierarchy(cls, name: str) -> "HierarchyFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return HierarchyFields("hierarchy", arguments=cleared_arguments)

    id: "DimensionGraphQLField" = DimensionGraphQLField("id")
    name: "DimensionGraphQLField" = DimensionGraphQLField("name")

    def fields(
        self, *subfields: Union[DimensionGraphQLField, "CubeFields", "HierarchyFields"]
    ) -> "DimensionFields":
        """Subfields should come from the DimensionFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "DimensionFields":
        self._alias = alias
        return self


class FileSystemDataSourceDataModelFields(GraphQLField):
    @classmethod
    def files(cls) -> "FileSystemFileFields":
        return FileSystemFileFields("files")

    def fields(
        self,
        *subfields: Union[
            FileSystemDataSourceDataModelGraphQLField, "FileSystemFileFields"
        ]
    ) -> "FileSystemDataSourceDataModelFields":
        """Subfields should come from the FileSystemDataSourceDataModelFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "FileSystemDataSourceDataModelFields":
        self._alias = alias
        return self


class FileSystemDataSourceLoadFields(GraphQLField):
    glob: "FileSystemDataSourceLoadGraphQLField" = FileSystemDataSourceLoadGraphQLField(
        "glob"
    )
    type: "FileSystemDataSourceLoadGraphQLField" = FileSystemDataSourceLoadGraphQLField(
        "type"
    )

    def fields(
        self, *subfields: FileSystemDataSourceLoadGraphQLField
    ) -> "FileSystemDataSourceLoadFields":
        """Subfields should come from the FileSystemDataSourceLoadFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "FileSystemDataSourceLoadFields":
        self._alias = alias
        return self


class FileSystemFileFields(GraphQLField):
    path: "FileSystemFileGraphQLField" = FileSystemFileGraphQLField("path")
    type: "FileSystemFileGraphQLField" = FileSystemFileGraphQLField("type")

    def fields(self, *subfields: FileSystemFileGraphQLField) -> "FileSystemFileFields":
        """Subfields should come from the FileSystemFileFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "FileSystemFileFields":
        self._alias = alias
        return self


class HierarchyFields(GraphQLField):
    are_members_indexed_by_name: "HierarchyGraphQLField" = HierarchyGraphQLField(
        "areMembersIndexedByName"
    )
    caption: "HierarchyGraphQLField" = HierarchyGraphQLField("caption")

    @classmethod
    def dimension(cls) -> "DimensionFields":
        return DimensionFields("dimension")

    id: "HierarchyGraphQLField" = HierarchyGraphQLField("id")
    is_slicing: "HierarchyGraphQLField" = HierarchyGraphQLField("isSlicing")
    is_virtual: "HierarchyGraphQLField" = HierarchyGraphQLField("isVirtual")
    is_visible: "HierarchyGraphQLField" = HierarchyGraphQLField("isVisible")

    @classmethod
    def level(cls, name: str) -> "LevelFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return LevelFields("level", arguments=cleared_arguments)

    @classmethod
    def levels(cls) -> "LevelFields":
        return LevelFields("levels")

    name: "HierarchyGraphQLField" = HierarchyGraphQLField("name")

    def fields(
        self, *subfields: Union[HierarchyGraphQLField, "DimensionFields", "LevelFields"]
    ) -> "HierarchyFields":
        """Subfields should come from the HierarchyFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "HierarchyFields":
        self._alias = alias
        return self


class IdentifiedDataSourceLoadFields(GraphQLField):
    @classmethod
    def data_source_identifier(cls) -> "DataSourceIdentifierFields":
        return DataSourceIdentifierFields("data_source_identifier")

    data_source_load: "DataSourceLoadUnion" = DataSourceLoadUnion("dataSourceLoad")

    def fields(
        self,
        *subfields: Union[
            IdentifiedDataSourceLoadGraphQLField,
            "DataSourceIdentifierFields",
            "DataSourceLoadUnion",
        ]
    ) -> "IdentifiedDataSourceLoadFields":
        """Subfields should come from the IdentifiedDataSourceLoadFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "IdentifiedDataSourceLoadFields":
        self._alias = alias
        return self


class JdbcDataSourceLoadFields(GraphQLField):
    @classmethod
    def parameters(cls) -> "ParameterFields":
        return ParameterFields("parameters")

    query: "JdbcDataSourceLoadGraphQLField" = JdbcDataSourceLoadGraphQLField("query")

    def fields(
        self, *subfields: Union[JdbcDataSourceLoadGraphQLField, "ParameterFields"]
    ) -> "JdbcDataSourceLoadFields":
        """Subfields should come from the JdbcDataSourceLoadFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "JdbcDataSourceLoadFields":
        self._alias = alias
        return self


class JoinFields(GraphQLField):
    id: "JoinGraphQLField" = JoinGraphQLField("id")
    is_partial: "JoinGraphQLField" = JoinGraphQLField("isPartial")

    @classmethod
    def mapping_item(cls, source_column_name: str) -> "JoinMappingItemFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "sourceColumnName": {"type": "String!", "value": source_column_name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return JoinMappingItemFields("mapping_item", arguments=cleared_arguments)

    @classmethod
    def mapping_items(cls) -> "JoinMappingItemFields":
        return JoinMappingItemFields("mapping_items")

    name: "JoinGraphQLField" = JoinGraphQLField("name")

    @classmethod
    def source(cls) -> "TableFields":
        return TableFields("source")

    @classmethod
    def target(cls) -> "TableFields":
        return TableFields("target")

    target_optionality: "JoinGraphQLField" = JoinGraphQLField("targetOptionality")

    def fields(
        self,
        *subfields: Union[JoinGraphQLField, "JoinMappingItemFields", "TableFields"]
    ) -> "JoinFields":
        """Subfields should come from the JoinFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "JoinFields":
        self._alias = alias
        return self


class JoinMappingItemFields(GraphQLField):
    id: "JoinMappingItemGraphQLField" = JoinMappingItemGraphQLField("id")

    @classmethod
    def source(cls) -> "ColumnFields":
        return ColumnFields("source")

    @classmethod
    def target(cls) -> "ColumnFields":
        return ColumnFields("target")

    def fields(
        self, *subfields: Union[JoinMappingItemGraphQLField, "ColumnFields"]
    ) -> "JoinMappingItemFields":
        """Subfields should come from the JoinMappingItemFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "JoinMappingItemFields":
        self._alias = alias
        return self


class LevelFields(GraphQLField):
    caption: "LevelGraphQLField" = LevelGraphQLField("caption")

    @classmethod
    def hierarchy(cls) -> "HierarchyFields":
        return HierarchyFields("hierarchy")

    id: "LevelGraphQLField" = LevelGraphQLField("id")
    name: "LevelGraphQLField" = LevelGraphQLField("name")
    type: "LevelGraphQLField" = LevelGraphQLField("type")

    def fields(
        self, *subfields: Union[LevelGraphQLField, "HierarchyFields"]
    ) -> "LevelFields":
        """Subfields should come from the LevelFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "LevelFields":
        self._alias = alias
        return self


class MeasureFields(GraphQLField):
    caption: "MeasureGraphQLField" = MeasureGraphQLField("caption")

    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    description: "MeasureGraphQLField" = MeasureGraphQLField("description")
    folder: "MeasureGraphQLField" = MeasureGraphQLField("folder")
    formatter: "MeasureGraphQLField" = MeasureGraphQLField("formatter")
    id: "MeasureGraphQLField" = MeasureGraphQLField("id")
    is_visible: "MeasureGraphQLField" = MeasureGraphQLField("isVisible")
    name: "MeasureGraphQLField" = MeasureGraphQLField("name")

    def fields(
        self, *subfields: Union[MeasureGraphQLField, "CubeFields"]
    ) -> "MeasureFields":
        """Subfields should come from the MeasureFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "MeasureFields":
        self._alias = alias
        return self


class NodeInterface(GraphQLField):
    id: "NodeGraphQLField" = NodeGraphQLField("id")

    def fields(self, *subfields: NodeGraphQLField) -> "NodeInterface":
        """Subfields should come from the NodeInterface class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "NodeInterface":
        self._alias = alias
        return self

    def on(self, type_name: str, *subfields: GraphQLField) -> "NodeInterface":
        self._inline_fragments[type_name] = subfields
        return self


class ParameterFields(GraphQLField):
    name: "ParameterGraphQLField" = ParameterGraphQLField("name")
    value: "ParameterGraphQLField" = ParameterGraphQLField("value")

    def fields(self, *subfields: ParameterGraphQLField) -> "ParameterFields":
        """Subfields should come from the ParameterFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "ParameterFields":
        self._alias = alias
        return self


class TableFields(GraphQLField):
    @classmethod
    def column(cls, name: str) -> "ColumnFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return ColumnFields("column", arguments=cleared_arguments)

    @classmethod
    def columns(cls) -> "ColumnFields":
        return ColumnFields("columns")

    data_loads: "DataLoadUnion" = DataLoadUnion("dataLoads")

    @classmethod
    def data_model(cls) -> "DataModelFields":
        return DataModelFields("data_model")

    id: "TableGraphQLField" = TableGraphQLField("id")

    @classmethod
    def join(cls, name: str) -> "JoinFields":
        arguments: Dict[str, Dict[str, Any]] = {
            "name": {"type": "String!", "value": name}
        }
        cleared_arguments = {
            key: value for key, value in arguments.items() if value["value"] is not None
        }
        return JoinFields("join", arguments=cleared_arguments)

    @classmethod
    def joins(cls) -> "JoinFields":
        return JoinFields("joins")

    name: "TableGraphQLField" = TableGraphQLField("name")

    @classmethod
    def primary_index(cls) -> "ColumnFields":
        return ColumnFields("primary_index")

    def fields(
        self,
        *subfields: Union[
            TableGraphQLField,
            "ColumnFields",
            "DataLoadUnion",
            "DataModelFields",
            "JoinFields",
        ]
    ) -> "TableFields":
        """Subfields should come from the TableFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "TableFields":
        self._alias = alias
        return self


class UpdatableCellsFields(GraphQLField):
    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    @classmethod
    def hierarchies(cls) -> "HierarchyFields":
        return HierarchyFields("hierarchies")

    id: "UpdatableCellsGraphQLField" = UpdatableCellsGraphQLField("id")

    @classmethod
    def levels(cls) -> "LevelFields":
        return LevelFields("levels")

    roles: "UpdatableCellsGraphQLField" = UpdatableCellsGraphQLField("roles")

    def fields(
        self,
        *subfields: Union[
            UpdatableCellsGraphQLField, "CubeFields", "HierarchyFields", "LevelFields"
        ]
    ) -> "UpdatableCellsFields":
        """Subfields should come from the UpdatableCellsFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdatableCellsFields":
        self._alias = alias
        return self


class UpdateAggregateCacheOutputFields(GraphQLField):
    @classmethod
    def aggregate_cache(cls) -> "AggregateCacheFields":
        return AggregateCacheFields("aggregate_cache")

    def fields(
        self,
        *subfields: Union[
            UpdateAggregateCacheOutputGraphQLField, "AggregateCacheFields"
        ]
    ) -> "UpdateAggregateCacheOutputFields":
        """Subfields should come from the UpdateAggregateCacheOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateAggregateCacheOutputFields":
        self._alias = alias
        return self


class UpdateColumnOutputFields(GraphQLField):
    @classmethod
    def column(cls) -> "ColumnFields":
        return ColumnFields("column")

    def fields(
        self, *subfields: Union[UpdateColumnOutputGraphQLField, "ColumnFields"]
    ) -> "UpdateColumnOutputFields":
        """Subfields should come from the UpdateColumnOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateColumnOutputFields":
        self._alias = alias
        return self


class UpdateCubeRestrictionsOutputFields(GraphQLField):
    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    def fields(
        self, *subfields: Union[UpdateCubeRestrictionsOutputGraphQLField, "CubeFields"]
    ) -> "UpdateCubeRestrictionsOutputFields":
        """Subfields should come from the UpdateCubeRestrictionsOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateCubeRestrictionsOutputFields":
        self._alias = alias
        return self


class UpdateDatabaseOutputFields(GraphQLField):
    @classmethod
    def database(cls) -> "DatabaseFields":
        return DatabaseFields("database")

    def fields(
        self, *subfields: Union[UpdateDatabaseOutputGraphQLField, "DatabaseFields"]
    ) -> "UpdateDatabaseOutputFields":
        """Subfields should come from the UpdateDatabaseOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateDatabaseOutputFields":
        self._alias = alias
        return self


class UpdateHierarchyOutputFields(GraphQLField):
    @classmethod
    def hierarchy(cls) -> "HierarchyFields":
        return HierarchyFields("hierarchy")

    def fields(
        self, *subfields: Union[UpdateHierarchyOutputGraphQLField, "HierarchyFields"]
    ) -> "UpdateHierarchyOutputFields":
        """Subfields should come from the UpdateHierarchyOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateHierarchyOutputFields":
        self._alias = alias
        return self


class UpdateUpdatableCellsOutputFields(GraphQLField):
    @classmethod
    def cube(cls) -> "CubeFields":
        return CubeFields("cube")

    def fields(
        self, *subfields: Union[UpdateUpdatableCellsOutputGraphQLField, "CubeFields"]
    ) -> "UpdateUpdatableCellsOutputFields":
        """Subfields should come from the UpdateUpdatableCellsOutputFields class"""
        self._subfields.extend(subfields)
        return self

    def alias(self, alias: str) -> "UpdateUpdatableCellsOutputFields":
        self._alias = alias
        return self
